package adminbenefactorservice

import (
	"context"

	param "git.gocasts.ir/ebhomengo/niki/param/admin/benefactor"
	response "git.gocasts.ir/ebhomengo/niki/pkg/response_builder"
	richerror "git.gocasts.ir/ebhomengo/niki/pkg/rich_error"
)

func (s Service) GetByID(ctx context.Context, req param.GetBenefactorByIDRequest) (param.GetBenefactorByIDResponse, error) {
	const op = "adminbenefactorservice.GetByID"

	bnf, gErr := s.repo.GetByID(ctx, req.BenefactorID)
	if gErr != nil {
		return param.GetBenefactorByIDResponse{}, richerror.New(op).WithErr(gErr)
	}

	return param.GetBenefactorByIDResponse{
		Data: param.Data{
			ID:          bnf.ID,
			FirstName:   bnf.FirstName,
			LastName:    bnf.LastName,
			PhoneNumber: bnf.PhoneNumber,
			Description: bnf.Description,
			Email:       bnf.Email,
			Gender:      bnf.Gender,
			BirthDate:   response.GetNullDate(bnf.BirthDate),
			Status:      bnf.Status,
		},
	}, nil
}

func (s Service) BenefactorExistByID(ctx context.Context, req param.BenefactorExistByIDRequest) (param.BenefactorExistByIDResponse, error) {
	const op = "adminbenefactorservice.BenefactorExistByID"

	isExisted, err := s.repo.IsExistBenefactorByID(ctx, req.ID)
	if err != nil {
		return param.BenefactorExistByIDResponse{}, richerror.New(op).WithErr(err).WithKind(richerror.KindUnexpected)
	}

	return param.BenefactorExistByIDResponse{Existed: isExisted}, nil
}
